/*
SIGNATURE API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package signaturesapi

import (
	"encoding/json"
)

// checks if the DocumentData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &DocumentData{}

// DocumentData struct for DocumentData
type DocumentData struct {
	Language string `json:"language"`
	Gender string `json:"gender"`
	Firstname string `json:"firstname"`
	Lastname string `json:"lastname"`
	Phone string `json:"phone"`
	Birthday string `json:"birthday"`
	Address Address `json:"address"`
	Email string `json:"email"`
	Attributes map[string]interface{} `json:"attributes"`
}

// NewDocumentData instantiates a new DocumentData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewDocumentData(language string, gender string, firstname string, lastname string, phone string, birthday string, address Address, email string, attributes map[string]interface{}) *DocumentData {
	this := DocumentData{}
	this.Language = language
	this.Gender = gender
	this.Firstname = firstname
	this.Lastname = lastname
	this.Phone = phone
	this.Birthday = birthday
	this.Address = address
	this.Email = email
	this.Attributes = attributes
	return &this
}

// NewDocumentDataWithDefaults instantiates a new DocumentData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewDocumentDataWithDefaults() *DocumentData {
	this := DocumentData{}
	return &this
}

// GetLanguage returns the Language field value
func (o *DocumentData) GetLanguage() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Language
}

// GetLanguageOk returns a tuple with the Language field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetLanguageOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Language, true
}

// SetLanguage sets field value
func (o *DocumentData) SetLanguage(v string) {
	o.Language = v
}

// GetGender returns the Gender field value
func (o *DocumentData) GetGender() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Gender
}

// GetGenderOk returns a tuple with the Gender field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetGenderOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Gender, true
}

// SetGender sets field value
func (o *DocumentData) SetGender(v string) {
	o.Gender = v
}

// GetFirstname returns the Firstname field value
func (o *DocumentData) GetFirstname() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Firstname
}

// GetFirstnameOk returns a tuple with the Firstname field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetFirstnameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Firstname, true
}

// SetFirstname sets field value
func (o *DocumentData) SetFirstname(v string) {
	o.Firstname = v
}

// GetLastname returns the Lastname field value
func (o *DocumentData) GetLastname() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Lastname
}

// GetLastnameOk returns a tuple with the Lastname field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetLastnameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Lastname, true
}

// SetLastname sets field value
func (o *DocumentData) SetLastname(v string) {
	o.Lastname = v
}

// GetPhone returns the Phone field value
func (o *DocumentData) GetPhone() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Phone
}

// GetPhoneOk returns a tuple with the Phone field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetPhoneOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Phone, true
}

// SetPhone sets field value
func (o *DocumentData) SetPhone(v string) {
	o.Phone = v
}

// GetBirthday returns the Birthday field value
func (o *DocumentData) GetBirthday() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Birthday
}

// GetBirthdayOk returns a tuple with the Birthday field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetBirthdayOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Birthday, true
}

// SetBirthday sets field value
func (o *DocumentData) SetBirthday(v string) {
	o.Birthday = v
}

// GetAddress returns the Address field value
func (o *DocumentData) GetAddress() Address {
	if o == nil {
		var ret Address
		return ret
	}

	return o.Address
}

// GetAddressOk returns a tuple with the Address field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetAddressOk() (*Address, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Address, true
}

// SetAddress sets field value
func (o *DocumentData) SetAddress(v Address) {
	o.Address = v
}

// GetEmail returns the Email field value
func (o *DocumentData) GetEmail() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Email
}

// GetEmailOk returns a tuple with the Email field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetEmailOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Email, true
}

// SetEmail sets field value
func (o *DocumentData) SetEmail(v string) {
	o.Email = v
}

// GetAttributes returns the Attributes field value
func (o *DocumentData) GetAttributes() map[string]interface{} {
	if o == nil {
		var ret map[string]interface{}
		return ret
	}

	return o.Attributes
}

// GetAttributesOk returns a tuple with the Attributes field value
// and a boolean to check if the value has been set.
func (o *DocumentData) GetAttributesOk() (map[string]interface{}, bool) {
	if o == nil {
		return map[string]interface{}{}, false
	}
	return o.Attributes, true
}

// SetAttributes sets field value
func (o *DocumentData) SetAttributes(v map[string]interface{}) {
	o.Attributes = v
}

func (o DocumentData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o DocumentData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["language"] = o.Language
	toSerialize["gender"] = o.Gender
	toSerialize["firstname"] = o.Firstname
	toSerialize["lastname"] = o.Lastname
	toSerialize["phone"] = o.Phone
	toSerialize["birthday"] = o.Birthday
	toSerialize["address"] = o.Address
	toSerialize["email"] = o.Email
	toSerialize["attributes"] = o.Attributes
	return toSerialize, nil
}

type NullableDocumentData struct {
	value *DocumentData
	isSet bool
}

func (v NullableDocumentData) Get() *DocumentData {
	return v.value
}

func (v *NullableDocumentData) Set(val *DocumentData) {
	v.value = val
	v.isSet = true
}

func (v NullableDocumentData) IsSet() bool {
	return v.isSet
}

func (v *NullableDocumentData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableDocumentData(val *DocumentData) *NullableDocumentData {
	return &NullableDocumentData{value: val, isSet: true}
}

func (v NullableDocumentData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableDocumentData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


